PF-build.sh 59 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025102610271028102910301031103210331034103510361037103810391040104110421043104410451046104710481049105010511052105310541055105610571058105910601061106210631064106510661067106810691070107110721073107410751076107710781079108010811082108310841085108610871088108910901091109210931094109510961097109810991100110111021103110411051106110711081109111011111112111311141115111611171118111911201121112211231124112511261127112811291130113111321133113411351136113711381139114011411142114311441145114611471148114911501151115211531154115511561157115811591160116111621163116411651166116711681169117011711172117311741175117611771178117911801181118211831184118511861187118811891190119111921193119411951196
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.2.0-Build_49
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. # 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
  139. # 12 Feb 2021, 3d-gussner, Add MK404-build.sh
  140. # 13 Feb 2021, 3d-gussner, Indentations
  141. # 13 Feb 2021, 3d-gussner, MK404 improvements like "flash" MK3, MK3S languages files to MK404 xflash.
  142. # 27 Feb 2021, 3d-gussner, Add './lang-community.sh' and update exits
  143. # 03 May 2021, 3d-gussner, Update exit numbers
  144. # 01-14 prepare build env
  145. # 21-32 prepare compiling
  146. # 41-47 compiling
  147. # 51-54 cleanup
  148. # 61-62 MK404
  149. # 03 May 2021, 3d-gussner, Update documentation and change version to v1.2.0
  150. # 03 May 2021, 3d-gussner, Add SIM atmega404
  151. #### Start check if OSTYPE is supported
  152. OS_FOUND=$( command -v uname)
  153. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  154. linux*)
  155. TARGET_OS="linux"
  156. ;;
  157. msys*|cygwin*|mingw*)
  158. # or possible 'bash on windows'
  159. TARGET_OS='windows'
  160. ;;
  161. nt|win*)
  162. TARGET_OS='windows'
  163. ;;
  164. *)
  165. TARGET_OS='unknown'
  166. ;;
  167. esac
  168. # Windows
  169. if [ $TARGET_OS == "windows" ]; then
  170. if [ $(uname -m) == "x86_64" ]; then
  171. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  172. Processor="64"
  173. elif [ $(uname -m) == "i386" ]; then
  174. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  175. Processor="32"
  176. else
  177. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  178. echo "Please refer to the notes of build.sh$(tput sgr0)"
  179. exit 1
  180. fi
  181. # Linux
  182. elif [ $TARGET_OS == "linux" ]; then
  183. if [ $(uname -m) == "x86_64" ]; then
  184. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  185. Processor="64"
  186. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  187. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  188. Processor="32"
  189. else
  190. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  191. echo "Please refer to the notes of build.sh$(tput sgr0)"
  192. exit 1
  193. fi
  194. else
  195. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  196. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  197. echo "Read the notes of build.sh$(tput sgr0)"
  198. exit 1
  199. fi
  200. sleep 2
  201. #### End check if OSTYPE is supported
  202. #### Prepare bash environment and check if wget, zip and other needed things are available
  203. # Check wget
  204. if ! type wget > /dev/null; then
  205. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  206. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  207. exit 2
  208. fi
  209. # Check for zip
  210. if ! type zip > /dev/null; then
  211. if [ $TARGET_OS == "windows" ]; then
  212. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  213. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  214. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  215. echo "Run git Bash under Administrator privilege and"
  216. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  217. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  218. exit 3
  219. elif [ $TARGET_OS == "linux" ]; then
  220. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  221. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  222. #sudo apt-get update && apt-get install zip
  223. exit 3
  224. fi
  225. fi
  226. # Check python ... needed during language build
  227. if ! type python > /dev/null; then
  228. if [ $TARGET_OS == "windows" ]; then
  229. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  230. exit 4
  231. elif [ $TARGET_OS == "linux" ]; then
  232. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  233. echo "As Python 2.x will not be maintained from 2020 please,"
  234. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  235. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  236. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  237. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  238. exit 4
  239. fi
  240. fi
  241. # Check gawk ... needed during language build
  242. if ! type gawk > /dev/null; then
  243. if [ $TARGET_OS == "linux" ]; then
  244. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  245. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  246. #sudo apt-get update && apt-get install gawk
  247. exit 5
  248. fi
  249. fi
  250. #### End prepare bash / Linux environment
  251. # Check for options/flags
  252. while getopts b:c:d:f:g:h:i:l:m:n:o:p:v:x:?h flag
  253. do
  254. case "${flag}" in
  255. b) build_flag=${OPTARG};;
  256. c) clean_flag=${OPTARG};;
  257. d) devel_flag=${OPTARG};;
  258. f) board_flash_flag=${OPTARG};;
  259. g) graphics_flag=${OPTARG};;
  260. h) help_flag=1;;
  261. i) IDE_flag=${OPTARG};;
  262. l) language_flag=${OPTARG};;
  263. m) mk404_flag=${OPTARG};;
  264. n) new_build_flag=${OPTARG};;
  265. o) output_flag=${OPTARG};;
  266. p) prusa_flag=${OPTARG};;
  267. v) variant_flag=${OPTARG};;
  268. x) board_mem_flag=${OPTARG};;
  269. ?) help_flag=1;;
  270. esac
  271. done
  272. #
  273. # '?' 'h' argument usage and help
  274. if [ "$help_flag" == "1" ] ; then
  275. echo "***************************************"
  276. echo "* PF-build.sh Version: 1.2.0-Build_49 *"
  277. echo "***************************************"
  278. echo "Arguments:"
  279. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  280. echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build'$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  281. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  282. echo "$(tput setaf 2)-f$(tput sgr0) Board flash size '$(tput setaf 2)256$(tput sgr0)','$(tput setaf 2)384$(tput sgr0)','$(tput setaf 2)512$(tput sgr0)','$(tput setaf 2)1024$(tput sgr0)''$(tput setaf 2)32M$(tput sgr0)'"
  283. echo "$(tput setaf 2)-g$(tput sgr0) Start MK404 grafics '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' lite '$(tput setaf 2)2$(tput sgr0)' fancy"
  284. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  285. echo "$(tput setaf 2)-i$(tput sgr0) Arduino IDE version '$(tput setaf 2)1.8.5$(tput sgr0)', '$(tput setaf 2)1.8.13$(tput sgr0)'"
  286. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  287. echo "$(tput setaf 2)-m$(tput sgr0) Start MK404 sim '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes '$(tput setaf 2)2$(tput sgr0)' with MMU2"
  288. echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  289. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  290. echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  291. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  292. echo "$(tput setaf 2)-x$(tput sgr0) Board memory size '$(tput setaf 2)8$(tput sgr0)' or '$(tput setaf 2)64$(tput sgr0)' Kb."
  293. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  294. echo
  295. echo "Brief USAGE:"
  296. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-v] [-l] [-d] [-b] [-o] [-c] [-p] [-n]"
  297. echo
  298. echo "Example:"
  299. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  300. echo " Will build all variants as multi language and final GOLD version"
  301. echo
  302. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
  303. echo " Will build MK3S multi language final GOLD firmware "
  304. echo " with current commit count number and output extra information,"
  305. echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
  306. echo
  307. exit 6
  308. fi
  309. #Check if Build is selected with argument '-f'
  310. if [ ! -z "$board_flash_flag" ] ; then
  311. if [ "$board_flash_flag" == "256" ] ; then
  312. BOARD_FLASH="0x3FFFF"
  313. BOARD_maximum_size="253952"
  314. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  315. elif [ "$board_flash_flag" == "384" ] ; then
  316. BOARD_FLASH="0x5FFFF"
  317. BOARD_maximum_size="385024"
  318. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  319. elif [ "$board_flash_flag" == "512" ] ; then
  320. BOARD_FLASH="0x7FFFF"
  321. BOARD_maximum_size="516096"
  322. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  323. elif [ "$board_flash_flag" == "1024" ] ; then
  324. BOARD_FLASH="0xFFFFF"
  325. BOARD_maximum_size="1040384"
  326. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  327. elif [[ "$board_flash_flag" == "32M" || "$board_flash_flag" == "32768" ]] ; then
  328. BOARD_FLASH="0x1FFFFFF"
  329. BOARD_maximum_size="33546240"
  330. echo "Board flash size : 32 Mb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  331. else
  332. echo "Unsupported board flash size chosen. Only '256', '384', '512', '1024' and '32M' are allowed."
  333. exit 7
  334. fi
  335. fi
  336. #Check if Build is selected with argument '-x'
  337. if [ ! -z "$board_mem_flag" ] ; then
  338. if [ "$board_mem_flag" == "8" ] ; then
  339. BOARD_MEM="0x21FF"
  340. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  341. elif [ "$board_mem_flag" == "64" ] ; then
  342. BOARD_MEM="0xFFFF"
  343. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  344. else
  345. echo "Unsupported board mem size chosen. Only '8', '64' are allowed."
  346. exit 8
  347. fi
  348. fi
  349. #Check if Arduino IDE version is correct
  350. if [ ! -z "$IDE_flag" ]; then
  351. if [[ "$IDE_flag" == "1.8.5" || "$IDE_flag" == "1.8.13" ]]; then
  352. ARDUINO_ENV="${IDE_flag}"
  353. else
  354. ARDUINO_ENV="1.8.5"
  355. fi
  356. else
  357. ARDUINO_ENV="1.8.5"
  358. fi
  359. #### Set build environment
  360. BUILD_ENV="1.0.6"
  361. BOARD="prusa_einsy_rambo"
  362. BOARD_PACKAGE_NAME="PrusaResearch"
  363. BOARD_VERSION="1.0.3"
  364. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  365. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  366. BOARD_FILENAME="prusa3dboards"
  367. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  368. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  369. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  370. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  371. LIB="PrusaLibrary"
  372. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  373. # List few useful data
  374. echo
  375. echo "Script path :" $SCRIPT_PATH
  376. echo "OS :" $OS
  377. echo "OS type :" $TARGET_OS
  378. echo ""
  379. echo "Arduino IDE :" $ARDUINO_ENV
  380. echo "Build env :" $BUILD_ENV
  381. echo "Board :" $BOARD
  382. if [ ! -z "$BOARD_FLASH" ] ; then
  383. echo "Board flash :" $BOARD_FLASH
  384. fi
  385. if [ ! -z "$BOARD_MEM" ] ; then
  386. echo "Board mem :" $BOARD_MEM
  387. fi
  388. echo "Package name:" $BOARD_PACKAGE_NAME
  389. echo "Board v. :" $BOARD_VERSION
  390. echo "Specific Lib:" $LIB
  391. echo ""
  392. #### Start prepare building environment
  393. #Check if build exists and creates it if not
  394. if [ ! -d "../PF-build-dl" ]; then
  395. mkdir ../PF-build-dl || exit 9
  396. fi
  397. cd ../PF-build-dl || exit 10
  398. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  399. # Check if PF-build-env-<version> exists and downloads + creates it if not
  400. # The build environment is based on the supported Arduino IDE portable version with some changes
  401. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  402. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  403. mkdir ../PF-build-env-$BUILD_ENV
  404. sleep 5
  405. fi
  406. # Download and extract supported Arduino IDE depending on OS
  407. # Windows
  408. if [ $TARGET_OS == "windows" ]; then
  409. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  410. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  411. sleep 2
  412. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 8
  413. echo "$(tput sgr 0)"
  414. fi
  415. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  416. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  417. sleep 2
  418. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 9
  419. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  420. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  421. echo "$(tput sgr0)"
  422. fi
  423. fi
  424. # Linux
  425. if [ $TARGET_OS == "linux" ]; then
  426. # 32 or 64 bit version
  427. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  428. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  429. sleep 2
  430. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  431. echo "$(tput sgr 0)"
  432. fi
  433. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  434. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  435. sleep 2
  436. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 9
  437. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  438. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  439. echo "$(tput sgr0)"
  440. fi
  441. fi
  442. # Make Arduino IDE portable
  443. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  444. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  445. fi
  446. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  447. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  448. fi
  449. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  450. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  451. fi
  452. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  453. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  454. fi
  455. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  456. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  457. fi
  458. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  459. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  460. fi
  461. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  462. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  463. fi
  464. # Change Arduino IDE preferences
  465. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  466. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  467. sleep 2
  468. echo "update.check"
  469. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  470. echo "board"
  471. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  472. echo "editor.linenumbers"
  473. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  474. echo "boardsmanager.additional.urls"
  475. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  476. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  477. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  478. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  479. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  480. echo "$(tput sgr0)"
  481. fi
  482. # Download and extract Prusa Firmware related parts
  483. # Download and extract PrusaResearchRambo board
  484. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  485. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  486. sleep 2
  487. wget $BOARD_FILE_URL || exit 10
  488. fi
  489. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  490. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  491. sleep 2
  492. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 11
  493. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  494. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  495. fi
  496. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  497. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  498. fi
  499. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  500. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  501. fi
  502. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  503. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  504. fi
  505. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  506. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  507. echo "$(tput sgr 0)"
  508. fi
  509. # Download and extract Prusa Firmware specific library files
  510. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  511. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  512. sleep 2
  513. wget $PF_BUILD_FILE_URL || exit 12
  514. echo "$(tput sgr 0)"
  515. fi
  516. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  517. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  518. sleep 2
  519. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 13
  520. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  521. echo "$(tput sgr0)"
  522. fi
  523. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  524. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  525. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  526. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  527. sleep 2
  528. fi
  529. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  530. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  531. sleep 2
  532. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  533. sleep 2
  534. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  535. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  536. echo "$(tput sgr0)"
  537. fi
  538. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  539. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  540. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  541. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  542. sleep 2
  543. echo "$(tput sgr0)"
  544. exit 14
  545. fi
  546. #### End prepare building
  547. #### Start
  548. cd $SCRIPT_PATH
  549. # Check if git is available
  550. if type git > /dev/null; then
  551. git_available="1"
  552. fi
  553. #
  554. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  555. if [ -z "$variant_flag" ] ; then
  556. # Select which variant of the Prusa Firmware will be compiled, like
  557. PS3="Select a variant: "
  558. while IFS= read -r -d $'\0' f; do
  559. options[i++]="$f"
  560. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  561. select opt in "${options[@]}" "All" "Quit"; do
  562. case $opt in
  563. *.h)
  564. VARIANT=$(basename "$opt" ".h")
  565. VARIANTS[i++]="$opt"
  566. break
  567. ;;
  568. "All")
  569. VARIANT="All"
  570. VARIANTS=${options[*]}
  571. break
  572. ;;
  573. "Quit")
  574. echo "You chose to stop"
  575. exit 22
  576. ;;
  577. *)
  578. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  579. ;;
  580. esac
  581. done
  582. else
  583. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  584. VARIANTS=$variant_flag
  585. elif [ "$variant_flag" == "All" ] ; then
  586. while IFS= read -r -d $'\0' f; do
  587. options[i++]="$f"
  588. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  589. VARIANT="All"
  590. VARIANTS=${options[*]}
  591. else
  592. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  593. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  594. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  595. echo "$(tput sgr0)"
  596. exit 23
  597. fi
  598. fi
  599. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  600. #Check default language mode
  601. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  602. if [ -z "$language_flag" ] ; then
  603. PS3="Select a language: "
  604. echo
  605. echo "Which lang-build do you want?"
  606. select yn in "Multi languages" "English only"; do
  607. case $yn in
  608. "Multi languages")
  609. LANGUAGES="ALL"
  610. break
  611. ;;
  612. "English only")
  613. LANGUAGES="EN_ONLY"
  614. break
  615. ;;
  616. *)
  617. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  618. ;;
  619. esac
  620. done
  621. else
  622. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  623. LANGUAGES=$language_flag
  624. else
  625. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  626. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  627. exit 24
  628. fi
  629. fi
  630. #Check if DEV_STATUS is selected via argument '-d'
  631. if [ ! -z "$devel_flag" ] ; then
  632. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  633. DEV_STATUS_SELECTED=$devel_flag
  634. elif [[ "$devel_flag" == "atmega404" || "$devel_flag" == "atmega404_no_bootloader" ]] ; then
  635. MK404_DEBUG=$devel_flag
  636. else
  637. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  638. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  639. exit 25
  640. fi
  641. fi
  642. #Check if Build is selected via argument '-b'
  643. if [ ! -z "$build_flag" ] ; then
  644. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  645. echo "Build changed to $build_flag"
  646. BUILD=$(git rev-list --count HEAD)
  647. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  648. BUILD=$build_flag
  649. else
  650. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  651. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  652. exit 26
  653. fi
  654. echo "New Build number is: $BUILD"
  655. fi
  656. # check if script has been started with arguments
  657. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  658. OUTPUT=1
  659. else
  660. OUTPUT=0
  661. fi
  662. #echo "Output is:" $OUTPUT
  663. #Check git branch has changed
  664. if [ ! -z "git_available" ]; then
  665. BRANCH=""
  666. CLEAN_PF_FW_BUILD=0
  667. else
  668. BRANCH=$(git branch --show-current)
  669. echo "Current branch is:" $BRANCH
  670. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  671. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  672. echo "created PF-build.branch file"
  673. else
  674. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  675. echo "Previous branch was:" $PRE_BRANCH
  676. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  677. CLEAN_PF_FW_BUILD=1
  678. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  679. fi
  680. fi
  681. fi
  682. #Set BUILD_ENV_PATH
  683. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 27
  684. BUILD_ENV_PATH="$( pwd -P )"
  685. cd ../..
  686. #Checkif BUILD_PATH exists and if not creates it
  687. if [ ! -d "Prusa-Firmware-build" ]; then
  688. mkdir Prusa-Firmware-build || exit 28
  689. fi
  690. #Set the BUILD_PATH for Arduino IDE
  691. cd Prusa-Firmware-build || exit 29
  692. BUILD_PATH="$( pwd -P )"
  693. #Check git branch has changed
  694. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  695. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  696. rm -r *
  697. else
  698. echo "Nothing to clean up"
  699. fi
  700. for v in ${VARIANTS[*]}
  701. do
  702. VARIANT=$(basename "$v" ".h")
  703. MK404_PRINTER=$(grep --max-count=1 "\bPRINTER_TYPE\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3 | cut -d '_' -f2)
  704. # Find firmware version in Configuration.h file and use it to generate the hex filename
  705. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  706. if [ -z "$BUILD" ] ; then
  707. # Find build version in Configuration.h file and use it to generate the hex filename
  708. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  709. else
  710. # Find and replace build version in Configuration.h file
  711. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  712. echo "Original build number: $BUILD_ORG"
  713. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  714. fi
  715. # Check if the motherboard is an EINSY and if so only one hex file will generated
  716. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  717. # Check development status
  718. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  719. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  720. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  721. DEV_STATUS="RC"
  722. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  723. DEV_STATUS="ALPHA"
  724. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  725. DEV_STATUS="BETA"
  726. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  727. DEV_STATUS="DEVEL"
  728. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  729. DEV_STATUS="DEBUG"
  730. else
  731. DEV_STATUS="UNKNOWN"
  732. echo
  733. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  734. PS3="Select YES only if source code is tested and trusted: "
  735. select yn in "Yes" "No"; do
  736. case $yn in
  737. Yes)
  738. DEV_STATUS="GOLD"
  739. DEV_STATUS_SELECTED="GOLD"
  740. break
  741. ;;
  742. No)
  743. DEV_STATUS="UNKNOWN"
  744. DEV_STATUS_SELECTED="UNKNOWN"
  745. break
  746. ;;
  747. *)
  748. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  749. ;;
  750. esac
  751. done
  752. fi
  753. else
  754. DEV_STATUS=$DEV_STATUS_SELECTED
  755. fi
  756. #Prepare hex files folders
  757. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  758. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  759. fi
  760. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  761. if [ "$BOARD" != "prusa_einsy_rambo" ]; then
  762. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD" ]; then
  763. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD || exit 28
  764. fi
  765. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$BOARD"
  766. fi
  767. #Check if exactly the same hexfile already exists
  768. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  769. echo ""
  770. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  771. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  772. if [ $OUTPUT == "1" ] ; then
  773. read -t 10 -p "Press Enter to continue..."
  774. fi
  775. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  776. echo ""
  777. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  778. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  779. if [ $OUTPUT == "1" ] ; then
  780. read -t 10 -p "Press Enter to continue..."
  781. fi
  782. fi
  783. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  784. echo ""
  785. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  786. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  787. if [ $OUTPUT == "1" ] ; then
  788. read -t 10 -p "Press Enter to continue..."
  789. fi
  790. fi
  791. #List some useful data
  792. echo "$(tput setaf 2)$(tput setab 7) "
  793. echo "Printer :" $MK404_PRINTER
  794. echo "Variant :" $VARIANT
  795. echo "Firmware :" $FW
  796. echo "Build # :" $BUILD
  797. echo "Dev Check :" $DEV_CHECK
  798. echo "DEV Status :" $DEV_STATUS
  799. echo "Motherboard:" $MOTHERBOARD
  800. echo "Board flash:" $BOARD_FLASH
  801. echo "Board mem :" $BOARD_MEM
  802. echo "Languages :" $LANGUAGES
  803. echo "Hex-file Folder:" $OUTPUT_FOLDER
  804. echo "$(tput sgr0)"
  805. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  806. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  807. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  808. else
  809. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  810. if [ $OUTPUT == "1" ] ; then
  811. read -t 10 -p "Press Enter to continue..."
  812. fi
  813. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  814. fi
  815. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  816. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  817. # set FW_REPOSITORY
  818. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  819. #Prepare English only or multi-language version to be build
  820. if [ $LANGUAGES == "EN_ONLY" ]; then
  821. echo " "
  822. echo "English only language firmware will be built"
  823. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  824. echo " "
  825. else
  826. echo " "
  827. echo "Multi-language firmware will be built"
  828. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  829. echo " "
  830. fi
  831. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  832. #if [ $TARGET_OS == "windows" ]; then
  833. #RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  834. #fi
  835. #New fresh PF-Firmware-build
  836. if [ "$new_build_flag" == "1" ]; then
  837. rm -r -f $BUILD_PATH/* || exit 54
  838. fi
  839. # Prepare Board mem and flash modifications
  840. ## Check board mem size
  841. CURRENT_BOARD_MEM=$(grep "#define RAMEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  842. if [ $CURRENT_BOARD_MEM != "0x21FF" ] ; then
  843. echo "Board mem has been already modified or not reset"
  844. echo "Current:" $CURRENT_BOARD_MEM
  845. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  846. select yn in "Yes" "No"; do
  847. case $yn in
  848. Yes)
  849. echo "Resetting board mem size"
  850. sed -i -- "s/^#define RAMEND .*$/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  851. break
  852. ;;
  853. *)
  854. echo "Continuing with modified mem size"
  855. break
  856. ;;
  857. esac
  858. done
  859. fi
  860. ## Modify board mem size
  861. if [[ ! -z $BOARD_MEM && "$BOARD_MEM" != "0x21FF" ]] ; then
  862. echo "$(tput setaf 3)Modifying board memory size (hex):$(tput sgr 0)"
  863. echo "Old:" $CURRENT_BOARD_MEM
  864. echo "New:" $BOARD_MEM
  865. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  866. echo ""
  867. sed -i -- "s/^#define RAMEND 0x21FF/#define RAMEND ${BOARD_MEM}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  868. fi
  869. ## Check board flash size
  870. CURRENT_BOARD_FLASH=$(grep "#define FLASHEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  871. CURRENT_BOARD_maximum_size=$(grep "prusa_einsy_rambo.upload.maximum_size" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt |cut -d '=' -f2|tr -d $'\n')
  872. if [[ $CURRENT_BOARD_FLASH != "0x3FFFF" || $CURRENT_BOARD_maximum_size != "253952" ]] ; then
  873. echo "Board flash has been already modified or not reset"
  874. echo "Current flash size:" $CURRENT_BOARD_FLASH
  875. echo "Current max. size:" $CURRENT_BOARD_maximum_size
  876. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  877. select yn in "Yes" "No"; do
  878. case $yn in
  879. Yes)
  880. echo "$(tput setaf 1)Resetting board flash size$(tput sgr 0)"
  881. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  882. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  883. break
  884. ;;
  885. *)
  886. echo "$(tput setaf 3)Continuing with modified flash size$(tput sgr 0)"
  887. break
  888. ;;
  889. esac
  890. done
  891. fi
  892. ## Modify boad flash size
  893. if [[ ! -z $BOARD_FLASH && "$BOARD_FLASH" != "0x3FFFF" ]] ; then
  894. echo "Modifying board flash size (hex):"
  895. echo "Old flash size:" $CURRENT_BOARD_FLASH
  896. echo "New flash size:" $BOARD_FLASH
  897. echo "Old max. size:" $CURRENT_BOARD_maximum_size
  898. echo "New max. size:" $BOARD_maximum_size
  899. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  900. sed -i -- "s/^#define FLASHEND .*/#define FLASHEND ${BOARD_FLASH}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  901. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=${BOARD_maximum_size}/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  902. fi
  903. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  904. # if [ $TARGET_OS == "windows" ]; then
  905. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  906. # fi
  907. #### End of Prepare building
  908. #### Start building
  909. export ARDUINO=$BUILD_ENV_PATH
  910. #echo $BUILD_ENV_PATH
  911. #export BUILDER=$ARDUINO/arduino-builder
  912. echo
  913. #read -t 5 -p "Press Enter..."
  914. echo
  915. echo "Start to build Prusa Firmware ..."
  916. echo "Using variant $VARIANT$(tput setaf 3)"
  917. if [ $OUTPUT == "1" ] ; then
  918. sleep 2
  919. fi
  920. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 41
  921. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 42
  922. echo "$(tput sgr 0)"
  923. if [ $LANGUAGES == "ALL" ]; then
  924. echo "$(tput setaf 2)"
  925. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  926. echo "$(tput sgr 0)"
  927. if [ $OUTPUT == "1" ] ; then
  928. sleep 2
  929. fi
  930. cd $SCRIPT_PATH/lang
  931. echo "$(tput setaf 3)"
  932. ./config.sh || exit 43
  933. echo "$(tput sgr 0)"
  934. # Check if previous languages and firmware build exist and if so clean them up
  935. if [ -f "lang_en.tmp" ]; then
  936. echo ""
  937. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  938. if [ $OUTPUT == "1" ] ; then
  939. read -t 10 -p "Press Enter to continue..."
  940. fi
  941. echo "$(tput setaf 3)"
  942. ./lang-clean.sh
  943. echo "$(tput sgr 0)"
  944. fi
  945. if [ -f "progmem.out" ]; then
  946. echo ""
  947. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  948. if [ $OUTPUT == "1" ] ; then
  949. read -t 10 -p "Press Enter to continue..."
  950. fi
  951. echo "$(tput setaf 3)"
  952. ./fw-clean.sh
  953. echo "$(tput sgr 0)"
  954. fi
  955. # build languages
  956. echo "$(tput setaf 3)"
  957. ./lang-build.sh || exit 44
  958. # build community languages
  959. ./lang-community.sh || exit 45
  960. # Combine compiled firmware with languages
  961. ./fw-build.sh || exit 46
  962. cp not_tran.txt not_tran_$VARIANT.txt
  963. cp not_used.txt not_used_$VARIANT.txt
  964. echo "$(tput sgr 0)"
  965. # Check if the motherboard is an EINSY and if so only one hex file will generated
  966. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  967. # If the motherboard is an EINSY just copy one hexfile
  968. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  969. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  970. # Make a copy of "lang.bin" for MK404 MK3 and MK3S
  971. if [ ! -z "$mk404_flag" ]; then
  972. cp -f lang.bin $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin
  973. fi
  974. # End of "lang.bin" for MK3 and MK3S copy
  975. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  976. else
  977. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  978. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  979. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  980. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  981. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  982. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  983. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  984. cp -f firmware_nl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-nl.hex
  985. if [ $TARGET_OS == "windows" ]; then
  986. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  987. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  988. elif [ $TARGET_OS == "linux" ]; then
  989. # Make a copy for MK404 sim of MK2, MK2.5, MK2.5S firmware
  990. if [ ! -z "$mk404_flag" ]; then
  991. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  992. fi
  993. # End of MK2, MK2.5, MK2.5S firmware copy
  994. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  995. fi
  996. fi
  997. # Cleanup after build
  998. if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
  999. echo "$(tput setaf 3)"
  1000. ./fw-clean.sh || exit 51
  1001. ./lang-clean.sh || exit 52
  1002. echo "$(tput sgr 0)"
  1003. fi
  1004. else
  1005. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  1006. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 47
  1007. fi
  1008. # Cleanup Firmware
  1009. if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
  1010. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 53
  1011. fi
  1012. # Delete dupblicates
  1013. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  1014. then
  1015. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  1016. fi
  1017. # MK2 not supported in this branch
  1018. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  1019. then
  1020. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  1021. fi
  1022. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  1023. then
  1024. rm $SCRIPT_PATH/lang/not_tran.txt
  1025. fi
  1026. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  1027. then
  1028. rm $SCRIPT_PATH/lang/not_used.txt
  1029. fi
  1030. #New fresh PF-Firmware-build
  1031. if [ "$new_build_flag" == "1" ]; then
  1032. rm -r -f $BUILD_PATH/* || exit 54
  1033. fi
  1034. # Restore files to previous state
  1035. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  1036. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  1037. if [ ! -z "$BUILD_ORG" ] ; then
  1038. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  1039. fi
  1040. echo $MULTI_LANGUAGE_CHECK
  1041. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  1042. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1043. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1044. if [ $OUTPUT == "1" ] ; then
  1045. sleep 5
  1046. fi
  1047. # Restore build env files to previous state
  1048. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1049. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  1050. sed -i -- "s/^#define RAMEND.*/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1051. done
  1052. # Switch to hex path and list build files
  1053. cd $SCRIPT_PATH
  1054. echo "$(tput setaf 2) "
  1055. echo " "
  1056. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  1057. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  1058. #### End building
  1059. #### MK404 Simulator
  1060. # Check/compile MK404 sim
  1061. if [ ! -z "$mk404_flag" ]; then
  1062. ./MK404-build.sh -c1 || exit 61
  1063. # For Prusa MK2, MK2.5/S
  1064. if [ "$MOTHERBOARD" == "BOARD_RAMBO_MINI_1_3" ]; then
  1065. MK404_PRINTER="${MK404_PRINTER}_mR13"
  1066. else
  1067. if [[ "$mk404_flag" == "2" || "$mk404_flag" == "MMU2" || "$mk404_flag" == "MMU2S" ]]; then # Check if MMU2 is selected only for MK3/S
  1068. MK404_PRINTER="${MK404_PRINTER}MMU2"
  1069. fi
  1070. fi
  1071. # Run MK404 with 'debugcore' and/or 'bootloader-file'
  1072. echo "MK404_DEBUG --$MK404_DEBUG--"
  1073. if [ "$MK404_DEBUG" == "atmega404" ]; then
  1074. MK404_options="--debugcore"
  1075. elif [ "$MK404_DEBUG" == "atmega404_no_bootloader" ]; then
  1076. MK404_options='--debugcore --bootloader-file ""'
  1077. fi
  1078. # Run MK404 with grafics
  1079. if [ ! -z "$graphics_flag" ]; then
  1080. echo "MK404_options --$MK404_options--"
  1081. if [ ! -z "$MK404_options" ]; then
  1082. MK404_options="${MK404_options} --colour-extrusion --extrusion Quad_HR -g "
  1083. else
  1084. MK404_options="--colour-extrusion --extrusion Quad_HR -g "
  1085. fi
  1086. if [[ "$graphics_flag" == "1" || "$graphics_flag" == "lite" ]]; then
  1087. MK404_options="${MK404_options}lite"
  1088. elif [[ "$graphics_flag" == "2" || "$graphics_flag" == "fancy" ]]; then
  1089. MK404_options="${MK404_options}fancy"
  1090. else
  1091. echo "$(tput setaf 1)Unsupported MK404 graphics option $graphics_flag$(tput sgr 0)"
  1092. fi
  1093. fi
  1094. # Output some useful data
  1095. echo "Printer: $MK404_PRINTER"
  1096. echo "Options: $MK404_options"
  1097. # Change to MK404 build folder
  1098. cd ../MK404/master/build
  1099. # Copy language bin file for MK3 and MK3S to xflash
  1100. # if [ -f $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin ]; then
  1101. # echo "Copy 'FW$FW-Build$BUILD-$VARIANT-lang.bin' to 'Prusa_${MK404_PRINTER}_xflash.bin'"
  1102. # dd if=/dev/zero bs=1 count=262145 | tr "\000" "\377" >Prusa_${MK404_PRINTER}_xflash.bin
  1103. # dd if=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin of=Prusa_${MK404_PRINTER}_xflash.bin conv=notrunc
  1104. # fi
  1105. #Decide which hex file to use EN_ONLY or Multi language
  1106. if [ "$LANGUAGES" == "ALL" ]; then
  1107. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1108. else
  1109. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex
  1110. fi
  1111. # Start MK404
  1112. # default with serial output and terminal to manipulate it via terminal
  1113. ./MK404 Prusa_$MK404_PRINTER -s --terminal $MK404_options -f $MK404_firmware_file || exit 62
  1114. fi
  1115. #### End of MK404 Simulator